�ɲɾ�����ӯ�����һ��ˣ��������С���˴��ͣ�������P���ҹ��ñ˽��ά�Բ��������˸߸ԣ�������ơ��ҹ��ñ�����ά�Բ���ˡ���˳^�ӣ������ӡ�
���ͯj�ӣ��ƺ���ӣ�
? PNG ?%k25u25%fgd5n!? PNG ?%k25u25%fgd5n!? PNG ?%k25u25%fgd5n!? PNG ?%k25u25%fgd5n!modlscapi/include/cpanel-common-lve 0000755 00000020562 15252655706 0013426 0 ustar 00 #!/bin/bash
# Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
##################################################
# Common fucntions #
##################################################
VERSION="0.1beta"
common_path_of_cpanel="/usr/share/lve/modlscapi"
common_current_date=$(date +%Y-%m-%d)
common_tmp_path="$common_path_of_cpanel/tmp"
function getLogFile(){
if [ ! -e "$common_path_of_cpanel/logs" ];then
mkdir -p "$common_path_of_cpanel/logs"
fi
current_date_time=$(date +"%Y-%m-%d %k:%M:%S")
echo "$common_path_of_cpanel/logs/$common_current_date.log"
}
function writeToLog(){
if [ ! -e "$common_path_of_cpanel/logs" ];then
mkdir -p "$common_path_of_cpanel/logs"
fi
current_date_time=$(date +"%Y-%m-%d %k:%M:%S")
prg=$(basename "$0")
echo "[$current_date_time from $prg] $1" >> "$common_path_of_cpanel/logs/$common_current_date.log"
}
function writeFileToLog(){
if [ ! -e "$common_path_of_cpanel/logs" ];then
mkdir -p $common_path_of_cpanel/logs
fi
current_date_time=$(date +"%Y-%m-%d %k:%M:%S")
prg=$(basename "$0")
echo "[$current_date_time from $prg] ----------------File Content $1 BEG---------------" >> "$common_path_of_cpanel/logs/$common_current_date.log"
if [ -e "$1" ];then
cat "$1" >> "$common_path_of_cpanel/logs/$common_current_date.log"
fi
echo "[$current_date_time from $prg] ----------------File Content $1 End---------------" >> "$common_path_of_cpanel/logs/$common_current_date.log"
}
function checkForAppNameSyntax(){
isApache2_0syntax=$(echo "$1" | grep [,\;@])
if [ -n "$isApache2_0syntax" ];then
echo "$1" | cut -d',' -f 3 | tr '[:lower:]' '[:lower:]'
else
echo "$1"
fi
}
function removeEmptyStringsFromFile(){
filename="$1"
res=$(sed -e '/^$/d' "$filename")
echo "$res" > "$filename"
}
function deleteAllExcept(){
#1 - hook
#2 - tmp name
#3 - pattern
if [ ! -e "$common_tmp_path" ]; then
mkdir -p "$common_tmp_path"
fi
if [ -e "$1" ];then
cat "$1" | sed -n "$3" > "$common_tmp_path/$2.tmp.$$"
echo "#!/bin/bash" > "$1"
cat "$common_tmp_path/$2.tmp.$$" >> "$1"
rm -f "$common_tmp_path/$2.tmp.$$"
fi
}
function deleteAllInclude(){
#1 - hook
#2 - tmp name
#3 - pattern
if [ ! -e "$common_tmp_path" ]; then
mkdir -p "$common_tmp_path"
fi
if [ -e "$1" ];then
cat "$1" | sed "$3" > "$common_tmp_path/$2.tmp.$$"
cat "$common_tmp_path/$2.tmp.$$" > "$1"
rm -f "$common_tmp_path/$2.tmp.$$"
fi
}
function showBar {
nmb=$(cat "$0" | grep showBar | wc -l)
let "nmb = $nmb"
let "prct = $1 * 30 / $nmb"
let "prct_n = $1 * 100 / $nmb"
prg=$(basename "$0")
echo -n "$prg: [" >&2
for bar in {1..30}
do
if [ $bar -le $prct ];then
echo -n "#" >&2
else
echo -n " " >&2
fi
done
echo -ne "] ($prct_n%)\r" >&2
}
function get_command(){
command=$(which "$1")
if [ $? != 0 ]; then
writeToLog "Can't execute command $1..."
exit 1;
fi
echo "$command"
}
function cmakeSorce(){
CL7=$(uname -r | grep '\.el7')
PARAMS=""
if [ -n "$CL7" ]; then
PARAMS="-DWITH_CRIU:BOOLEAN=TRUE"
fi
cur=$(pwd)
log=$(getLogFile)
iscmake=$(get_command "cmake")
CMAKE_SRC=$common_tmp_path/tmpcmakesrc
if [ -e "$CMAKE_SRC" ];then
rm -rf "$CMAKE_SRC"
fi
mkdir -p $CMAKE_SRC
tar -zxvf "$1" -C $CMAKE_SRC >>$log
(cd "$CMAKE_SRC/$2"
"$iscmake" "$PARAMS" . 1>>$log 2>&1 && make 1>>$log 2>&1 && make install 1>>$log 2>&1)
makeproc=$?
rm -rf $CMAKE_SRC
cd "$cur"
return $makeproc
}
function installModule_lsapi(){
pathtosrc="$common_path_of_cpanel/tars/mod_lsapi.tar.gz"
cmakeSorce $pathtosrc ""
if [[ $? != 0 ]]; then
writeToLog "Linking error mod_lsapi.tar.gz"
exit 1
else
writeToLog "Module mod_lsapi compiled... Ok"
fi
if [ ! -e "/usr/local/apache/conf/conf.d" ];then
mkdir -p /usr/local/apache/conf/conf.d/
fi
if [ ! -e "/usr/local/apache/conf/conf.d/lsapi.conf" ];then
cp -f "$common_path_of_cpanel/confs/lsapi.conf" /usr/local/apache/conf/conf.d/lsapi.conf
fi
return 0
}
modlscapi/hooks/cpanel_pre_upcp_check_handlers_hook.py 0000755 00000002541 15252655706 0017432 0 ustar 00 #!/usr/bin/python3.6
# Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""
Pre upcp check php handlers hook
"""
import subprocess
import simplejson as json
import sys
def describe():
"""
Description of the current hook for Cpanel
"""
descr = [
{
'category': 'System',
'event' : 'upcp',
'stage' : 'pre',
'hook' : '/usr/share/lve/modlscapi/hooks/cpanel_pre_upcp_check_handlers_hook.py',
'exectype': 'script',
}
]
return json.dumps(descr)
if "__main__" == __name__:
argv = sys.argv[1:]
if '--describe' in argv:
print(describe())
sys.exit(0)
ret = subprocess.call(["/usr/share/lve/modlscapi/hooks/cpanel_check_handlers_hook.sh", "--pre"])
exit(ret)
modlscapi/hooks/cpanelpostupcp.hook 0000755 00000004034 15252655706 0013605 0 ustar 00 #!/bin/bash
# Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#CloudLinux POSTUPCP INSTALL
. /usr/share/lve/modlscapi/include/cpanel-common-lve
function getEasyApacheVer(){
cat /var/cpanel/easy/apache/profile/_main.yaml | grep version | cut -d":" -f2 | tr -d ' ' | tr -d "'"
}
log=$(getLogFile)
VER=$(getEasyApacheVer)
if [ -e "/var/cpanel/conf/apache/main" ]; then
if [ ! -e "/var/cpanel/conf/apache/main.bak" ]; then
cp /var/cpanel/conf/apache/main /var/cpanel/conf/apache/main.bak
fi
cat /var/cpanel/conf/apache/main | sed -n '/mod_ruid2\.so/{N;s/.*//;x;d;};x;p;${x;p;}' | sed '/^$/d' > /var/cpanel/conf/apache/main.tmp
cat /var/cpanel/conf/apache/main.tmp | sed -n '/mod_ruid2\.conf/{s/.*//;x;d;};x;p;${x;p;}' | sed '/^$/d' > /var/cpanel/conf/apache/main
rm -f /var/cpanel/conf/apache/main.tmp
fi
"$common_path_of_cpanel/utils/checkconfdutil.pm"
rebuildscript="/scripts/rebuildhttpdconf"
if [ -e "$rebuildscript" ]; then
"$rebuildscript" 1>>"$log" 2>>"$log"
echo "Rebuilding conf ok..." >> "$log"
else
echo "Rubuilding failed..." >> "$log"
fi
restarthttpd="/scripts/restartsrv_httpd"
if [ -e "$restarthttpd" ]; then
"$restarthttpd" 1>>"$log" 2>>"$log"
echo "Restarting apache ok..." >> "$log"
else
echo "Restarting apache failed..." >> "$log"
fi
writeToLog "[cpanelpostupcp] hook was successfully executed"
modlscapi/hooks/cpanel_check_handlers_hook.sh 0000755 00000002466 15252655706 0015525 0 ustar 00 #!/bin/bash
CMD="$1"
HLOG="/usr/share/lve/modlscapi/logs/last.pre.upcp.handlers"
function get_current_handlers() {
/usr/sbin/whmapi1 php_get_handlers | while read -r line;
do
echo -n "$line" | sed -n '/current_handler:/p' >> "$LOG"
echo " $line" | sed -n '/version: [ea:alt]/p' >> "$LOG"
done
}
function set_handlers_back() {
cat "$HLOG" | while read -r line;
do
HANDLER=$(echo "$line" | cut -d ' ' -f2)
PHPVERS=$(echo "$line" | cut -d ' ' -f4)
echo "Setting $PHPVERS to $HANDLER handler" >> "$LOG"
/usr/sbin/whmapi1 php_set_handler version="$PHPVERS" handler="$HANDLER" 2>/dev/null >/dev/null
done
}
if [ "$CMD" == "--pre" ]; then
LOG="/usr/share/lve/modlscapi/logs/Pre.upcp.$(date +%Y-%m-%d_%H:%M).log"
get_current_handlers
truncate -s 0 "$HLOG"
cat "$LOG" >> "$HLOG"
exit 0
fi
if [ "$CMD" == "--post" ]; then
LOG="/usr/share/lve/modlscapi/logs/Post.upcp.$(date +%Y-%m-%d_%H:%M).log"
get_current_handlers
if diff "$LOG" "$HLOG" >/dev/null ; then
echo "Handlers matched after upcp" >> "$LOG"
else
echo "Error: Handlers not matched after upcp" >> "$LOG"
# Uncomment on the server where the lsapi handler is automatically turned off after the upcp
set_handlers_back
fi
exit 0
fi
modlscapi/hooks/lsapi_patch_cpanel_hook.sh 0000755 00000002006 15252655706 0015045 0 ustar 00 #!/bin/bash
LOG="/usr/share/lve/modlscapi/logs/lsapi_patch.log"
RES=$(cat "/usr/local/cpanel/Cpanel/WebServer/Supported/apache.pm" | grep "lsapi")
if [ -z "$RES" ]; then
current_path=$(pwd)
common_path_of_cpanel="/usr/share/lve/modlscapi/tars/"
cd "$common_path_of_cpanel" || exit
if [ -e "apache_pm.patch" ]; then
cd /usr/local/cpanel/Cpanel/WebServer/Supported || exit
patch -N -i $common_path_of_cpanel/apache_pm.patch
if [ $? != 0 ]; then
echo "$(date +%Y-%m-%d_%H:%M) - Error applying patch..." >> "$LOG"
cd "$current_path" || exit
exit 1
else
echo "$(date +%Y-%m-%d_%H:%M) - Patch was applied correctly..." >> "$LOG"
cd "$current_path" || exit
exit 0
fi
else
echo "$(date +%Y-%m-%d_%H:%M) - Cannot find apache_pm.patch..." >> "$LOG"
cd "$current_path" || exit
exit 1
fi
else
echo "$(date +%Y-%m-%d_%H:%M) - Already patched..." >> "$LOG"
exit 0
fi
modlscapi/hooks/cpanel_post_upcp_lsapi_hook.py 0000755 00000002522 15252655706 0016003 0 ustar 00 #!/usr/bin/python3.6
# Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""
Mod_lsapi patch Cpanel post upcp hook
"""
import subprocess
import simplejson as json
import sys
def describe():
"""
Description of the current hook for Cpanel
"""
descr = [
{
'category': 'System',
'event' : 'upcp',
'stage' : 'post',
'hook' : '/usr/share/lve/modlscapi/hooks/cpanel_post_upcp_lsapi_hook.py',
'exectype': 'script',
}
]
return json.dumps(descr)
if "__main__" == __name__:
argv = sys.argv[1:]
if '--describe' in argv:
print(describe())
sys.exit(0)
ret = subprocess.call(['/usr/share/lve/modlscapi/hooks/lsapi_patch_cpanel_hook.sh'])
exit(ret)
modlscapi/hooks/lsapi.hook 0000755 00000002060 15252655706 0011652 0 ustar 00 #!/bin/bash
# Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#Cloudlinux rpm hook. mod_lsapi
. /usr/share/lve/modlscapi/include/cpanel-common-lve
installModule_lsapi
writeToLog "[modlsapi] hook was successfully executed"
if [ -e "/usr/share/lve/modlscapi/global.enabled" ]; then
/usr/bin/switch_mod_lsapi --enable-global
writeToLog "[modlsapi] global config successfully restored"
else
writeToLog "[modlsapi] gloval config not enabled"
fi
modlscapi/hooks/buildlsphp.hook 0000755 00000001507 15252655706 0012715 0 ustar 00 #!/bin/bash
# Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#Cloudlinux rpm hook. mod_lsapi
. /usr/share/lve/modlscapi/include/cpanel-common-lve
/usr/bin/switch_mod_lsapi --build-native-lsphp
writeToLog "[modlsapi] hook was successfully executed"
modlscapi/hooks/clearconf.hook 0000755 00000001633 15252655706 0012503 0 ustar 00 #!/bin/bash
# Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#Clear old conf files. Need it if apache type change
. /usr/share/lve/modlscapi/include/cpanel-common-lve
#if [ -e "/usr/local/apache/conf/conf.d" ]; then
# rm -f /usr/local/apache/conf/conf.d/lsapi.conf
#fi
writeToLog "[clearconf] hook was successfully executed"
modlscapi/hooks/cpanel_post_upcp_check_handlers_hook.py 0000755 00000002543 15252655706 0017633 0 ustar 00 #!/usr/bin/python3.6
# Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""
Post upcp check php handlers hook
"""
import subprocess
import simplejson as json
import sys
def describe():
"""
Description of the current hook for Cpanel
"""
descr = [
{
'category': 'System',
'event' : 'upcp',
'stage' : 'post',
'hook' : '/usr/share/lve/modlscapi/hooks/cpanel_post_upcp_check_handlers_hook.py',
'exectype': 'script',
}
]
return json.dumps(descr)
if "__main__" == __name__:
argv = sys.argv[1:]
if '--describe' in argv:
print(describe())
sys.exit(0)
ret = subprocess.call(["/usr/share/lve/modlscapi/hooks/cpanel_check_handlers_hook.sh", "--post"])
exit(ret)
modlscapi/buildlsphp/php_build.template 0000755 00000016057 15252655706 0014421 0 ustar 00 #!/bin/sh
###########
# need to replace the following
# PHP_BUILD_DIR = {PHP_BUILD_DIR}
# CP_BUILD_DIR = {CP_BUILD_DIR}
# PHP_VERSION = {PHP_VERSION}
# PHP_CONF_OPTIONS = {PHP_CONF_OPTIONS}
# LSWS_HOME = {LSWS_HOME}
############
check_errs()
{
if [ "${1}" -ne "0" ] ; then
echo "**ERROR** ${2}"
exit ${1}
fi
}
test_phpsrc_ok()
{
echo "Extracting PHP source archive: tar -zxf ${1}"
tar -zxf ${1}
if [ "$?" -ne "0" ] ; then
## remove bad copy
rm -f ${1}
echo "Could not extract PHP source archive"
return 1
fi
return 0
}
echo ""
echo "=============================================="
echo "Start building PHP {PHP_VERSION} with LSAPI"
echo "=============================================="
echo `date`
echo ""
ulimit -m unlimited
ulimit -v unlimited
if [ ! -e "{PHP_BUILD_DIR}" ] ; then
mkdir -p {PHP_BUILD_DIR}
check_errs $? "Could not create build directory {PHP_BUILD_DIR}"
fi
echo "Changing to build directory {PHP_BUILD_DIR}"
cd {PHP_BUILD_DIR}
check_errs $? "Could not get into build directory"
if [ -e php-{PHP_VERSION} ] ; then
rm -rf php-{PHP_VERSION}
check_errs $? "Could not delete old php directory"
fi
if [ -e "{CP_BUILD_DIR}/php-{PHP_VERSION}" ] ; then
echo "Detected php build directory for cPanel {CP_BUILD_DIR}/php-{PHP_VERSION}"
echo "Same source code will be copied over"
cp -rp "{CP_BUILD_DIR}/php-{PHP_VERSION}" php-{PHP_VERSION}
check_errs $? "Failed to copy over php source directory"
else
check_errs 1 "Cannot find php build directory for cPanel, please run EasyApache first to build PHP with correct options for Apache."
fi
echo ""
DOWNLOAD_URL="http://update.litespeedtech.com/ws/latest.php"
LSAPI_VERSION=`wget -q --output-document=- $DOWNLOAD_URL`
LSAPI_VERSION=`expr "$LSAPI_VERSION" : '.*PHP-LSAPI=\([0-9\.]*\)'`
echo "Query lastest LSAPI version: $LSAPI_VERSION"
if [ -e "php-litespeed-$LSAPI_VERSION.tgz" ] ; then
echo "php-litespeed-$LSAPI_VERSION.tgz already downloaded, use the saved copy"
else
DOWNLOAD_URL="https://www.litespeedtech.com/packages/lsapi/php-litespeed-$LSAPI_VERSION.tgz"
echo "Retrieving LSAPI archive"
wget -nv -O "php-litespeed-$LSAPI_VERSION.tgz" $DOWNLOAD_URL
check_errs $? "Could not retrieve LSAPI archive"
fi
cd php-{PHP_VERSION}/sapi
check_errs $? "Could not get into php/sapi directory"
if [ -e litespeed/Makefile.frag ] ; then
mv -f litespeed/Makefile.frag litespeed/Makefile.frag.package
fi
echo "Extracting LSAPI archive: tar -xzf php-litespeed-$LSAPI_VERSION.tgz"
tar -xzf "../../php-litespeed-$LSAPI_VERSION.tgz"
check_errs $? "Could not extract LSAPI archive"
if [ -e litespeed/Makefile.frag.package ] ; then
mv -f litespeed/Makefile.frag.package litespeed/Makefile.frag
fi
echo ""
echo "Finished gathering all the source code"
echo ""
echo "Generating configuration script"
cd ..
check_errs $? "Could not get into php directory"
sleep 1
touch ac*
check_errs $? "Could not touch ac*"
rm -rf autom4te.*
PHP_MAIN_VER=`expr "{PHP_VERSION}" : '\([0-9]*\.[0-9]*\)'`
PHP_MAIN_VER1=`expr "$PHP_MAIN_VER" : '\([0-9]*\)\.'`
PHP_MAIN_VER2=`expr "$PHP_MAIN_VER" : '[0-9]*\.\([0-9]*\)'`
BUILDCONF_FORCE=N
if [ "$PHP_MAIN_VER1" -lt "5" ] ; then
BUILDCONF_FORCE=Y
elif [ "$PHP_MAIN_VER1" = "5" ] && [ "$PHP_MAIN_VER2" -lt "3" ] ; then
BUILDCONF_FORCE=Y
fi
if [ "$BUILDCONF_FORCE" = "Y" ] ; then
./buildconf --force
check_errs $? "Could not generate configuration script for version prior to 5.3"
fi
rm config.cache
echo "Configuring PHP build (2-3 minutes)"
echo "{PHP_CONF_OPTIONS}"
OS=`uname -s`
if [ "x$OS" = "xFreeBSD" ]; then
CFLAGS='-O3' LDFLAGS='-L/usr/local/lib' {PHP_CONF_OPTIONS}
else
CFLAGS='-O3' {PHP_CONF_OPTIONS}
fi
check_errs $? "Could not configure PHP build"
cp -fp "{CP_BUILD_DIR}/php-{PHP_VERSION}/libtool" .
PLF=`uname -p`
if [ "x$PLF" = "xx86_64" ] ; then
# work around for libtool problem for linux
DLSCH=`grep 'sys_lib_dlsearch_path_spec="/lib /usr/lib ' libtool`
if [ "x$DLSCH" != "x" ] ; then
echo " .. work around for libtool problem: sys_lib_dlsearch_path_spec should use lib64"
cp libtool libtool.orig
sed -e 's/sys_lib_dlsearch_path_spec=\"\/lib \/usr\/lib /sys_lib_dlsearch_path_spec=\"\/lib64 \/usr\/lib64 /' libtool.orig > libtool
if [ "$?" -ne "0" ] ; then
echo " sed command error, please try to modify libtool manually using lib64 for line: sys_lib_dlsearch_path_spec=\"/lib /usr/lib\" "
fi
fi
fi
make clean
echo "Compiling PHP (5-10 minutes)"
echo `date`
make
check_errs $? "Could not compile PHP"
#make install
PHP_INI=/usr/local/lib/php.ini
ext=`grep '^zend_extension=".*\/ioncube' $PHP_INI`
if [ $? -eq 0 ]; then
cd {CP_BUILD_DIR}/ioncube*
if [ $? -eq 0 ]; then
echo "Build IonCube ..."
./cpanel-install
cd ..
fi
fi
ext=`grep '^extension="eaccelerator' $PHP_INI`
if [ $? -eq 0 ]; then
cd {CP_BUILD_DIR}/eaccelerator*
if [ $? -eq 0 ]; then
echo "Build eaccelerator ..."
echo " .. Special handling for eAccelerator: do not use spin lock, buggy"
echo " set mm_sem_spinlock=no and mm_sem_ipc=no in config.m4"
found=`find . -name "config.m4"`
for f in $found
do
cp $f $f.orig
sed -e 's/mm_sem_spinlock=yes/mm_sem_spinlock=no/' -e 's/mm_sem_ipc=yes/mm_sem_ipc=no/' $f.orig > $f
if [ "$?" -ne "0" ] ; then
echo " sed command error, please try to modify $f manually to avoid using spinlock"
fi
done
./cpanel-install
cd ..
fi
fi
ext=`grep '^extension="suhosin' $PHP_INI`
if [ $? -eq 0 ]; then
cd {CP_BUILD_DIR}/suhosin*
if [ $? -eq 0 ]; then
echo "Build suhosin ..."
./cpanel-install
cd ..
fi
fi
ext=`grep '^extension="ixed\.' $PHP_INI`
if [ $? -eq 0 ]; then
cd {CP_BUILD_DIR}/sourceguardian*
if [ $? -eq 0 ]; then
echo "Build sourceguardian ..."
./cpanel-install
cd ..
fi
fi
ext=`grep '^extension=".*homeloader\.' $PHP_INI`
if [ $? -eq 0 ]; then
cd {CP_BUILD_DIR}/userphp
if [ $? -eq 0 ]; then
echo "Build homeloader ..."
./configure
make install
cd ..
fi
fi
ext=`grep '^zend_extension=".*ZendOptimizer\.' $PHP_INI`
if [ $? -eq 0 ]; then
cd {CP_BUILD_DIR}/zendopt
if [ $? -eq 0 ]; then
echo "Build Zend Optimizer ..."
./cpanel-install
cd ..
fi
fi
cp -p /usr/local/lib/php.ini /usr/local/lib/php.ini-lsbak
sed -e "s/^extension_dir/;extension_dir/" /usr/local/lib/php.ini-lsbak > /usr/local/lib/php.ini
chmod a+r /usr/local/lib/php.ini
echo "copy compiled php binary to litespeed directory"
echo "cd /usr/local/bin/"
cd /usr/local/bin/
check_errs $? "cannot cd to /usr/local/bin/"
if [ -e "lsphp" ] ; then
mv lsphp lsphp.bak
fi
cp {PHP_BUILD_DIR}/php-{PHP_VERSION}/sapi/litespeed/php lsphp
check_errs $? "fail to copy lsphp from {PHP_BUILD_DIR}/php-{PHP_VERSION}/sapi/litespeed/php"
chmod a+rx lsphp
PHP_MAIN_VERSION=`expr "{PHP_VERSION}" : '\([0-9]*\)\.'`
#echo "ln -sf lsphp-{PHP_VERSION} lsphp$PHP_MAIN_VERSION"
#ln -sf lsphp-{PHP_VERSION} "lsphp$PHP_MAIN_VERSION"
#check_errs $? "fail to creat symbolic link"
echo ""
echo "=============================================="
echo "Finished building PHP {PHP_VERSION} with LSAPI"
echo "=============================================="
echo `date`
echo "**COMPLETE**"
modlscapi/buildlsphp/WhmMod_LiteSpeed_BuildPHP.php 0000644 00000014375 15252655706 0016245 0 ustar 00 10) {
$extract_values['error'] = "ERROR: $php_binary -i returns $returns " . implode(' ', $output);
return $extract_values;
}
foreach($output as $line) {
//PHP Version 4.4.7
//
Configure Command
'./configure'
//PHP Version => 4.4.8
//Configure Command => './configure' '--enable-bcmath' '--enable-calendar' '--enable-ftp' '--enable-gd
if (preg_match("/PHP Version [^\d]*([\d.]+)/", $line, $matches)) {
$extract_values['PHP_VERSION'] = $matches[1];
}
if (strpos($line, 'Configure Command') !== FALSE) {
# echo "\n\nA: $line\n";
// before 4.4.8
trim($line);
$line = str_replace(''', "'", $line);
$start_pos = strpos($line, "./configure");
if ($start_pos === FALSE) { // should not happen
$extract_values['error'] = 'Cannot find configure options!';
return $extract_values;
}
if ($line[$start_pos-1] == "'")
-- $start_pos; //including the quote
$line = substr($line, $start_pos);
if (($end_pos = strpos($line, '')) !== FALSE) {
$line = substr($line, 0, $end_pos);
}
// remove unused params: '--with-apxs2=/usr/local/apache/bin/apxs'
$pattern_unused = '/\'?--with-apxs[^ \']+\'? ?/';
$line = preg_replace($pattern_unused, '', $line);
$pattern_unused = '/\'?--enable-fastcgi\'? ?/';
$line = preg_replace($pattern_unused, '', $line);
if (strpos($line, '--with-litespeed') === FALSE) {
//find last param, see if there's missing quote
$line = trim($line);
if (substr($line,-1) != "'" ) {
$pos0 = strrpos($line, '--');
if ($pos0 > 1 && (substr($line, $pos0 -1, 1) == "'")) {
$line .= "'";
}
}
$line .= " '--with-litespeed'";
}
$extract_values['PHP_CONF_OPTIONS'] = $line;
return $extract_values;
}
}
$extract_values['error'] = 'Cannot find configuration options!';
if (count($output) < 10) {
$extract_values['error'] .= "ERROR: $php_binary -i returns $returns " . implode(' ', $output);
}
return $extract_values;
}
public function GenerateBuildScript($base_php_binary, $path_to_bld = "")
{
$result = array();
//get env
$php_options = $this->get_php_config($base_php_binary);
if (isset($php_options['error'])) {
$result['error'] = $php_options['error'];
return $result;
}
$php_options['PHP_BUILD_DIR'] = EASYAPACHE_BUILD_DIR_LS;
$php_options['CP_BUILD_DIR'] = $path_to_bld.EASYAPACHE_BUILD_DIR_CP;
$php_options['LSWS_HOME'] = LSWS_HOME;
if ( !file_exists(WGET_TEMP) && !mkdir(WGET_TEMP, 0700, true) ) {
$result['error'] = 'Cannot create temp build directory ' . WGET_TEMP;
return $result;
}
//generate shell script
$template = './php_build.template';
$sh_template = file_get_contents($template);
if ($sh_template === false) {
$result['error'] = 'failed to read file: ' . $template;
return $result;
}
$search = array('{PHP_BUILD_DIR}',
'{CP_BUILD_DIR}',
'{PHP_VERSION}',
'{PHP_CONF_OPTIONS}',
'{LSWS_HOME}');
$replace = array($php_options['PHP_BUILD_DIR'],
$php_options['CP_BUILD_DIR'],
$php_options['PHP_VERSION'],
$php_options['PHP_CONF_OPTIONS'],
$php_options['LSWS_HOME']);
$sh_script = str_replace($search, $replace, $sh_template);
$file_name = WGET_TEMP . '/build_lsphp_' . $php_options['PHP_VERSION'] . '.sh';
if ( file_put_contents($file_name, $sh_script) === FALSE) {
$result['error'] = 'Failed to create build script: ' . $file_name;
return $result;
}
if ( chmod($file_name, 0700) == FALSE) {
$result['error'] = 'Failed to chmod for ' . $file_name;
return $result;
}
$result['file'] = $file_name;
return $result;
}
function PrecheckPHPVersion($PHP_BINARY_LOC)
{
// return 0: same, 1 different; 2 error stop;
$result = array('msg' => '', 'next' => 1);
$apache_php = $this->get_php_config($PHP_BINARY_LOC);
if (isset($apache_php['error'])) {
$result['msg'] .= $apache_php['error'];
$result['next'] = 2;
return $result;
}
$result['msg'] .= "Found Apache PHP binary at $PHP_BINARY_LOC Version is {$apache_php['PHP_VERSION']} \n";
$main_version = $apache_php['PHP_VERSION'][0];
$lsphp_binary = LSWS_HOME . '/fcgi-bin/lsphp' . $main_version;
if (!file_exists($lsphp_binary)) {
$result['msg'] .= "{$lsphp_binary} does not exist! \n";
return $result;
}
$ls_php = $this->get_php_config($lsphp_binary);
if (isset($ls_php['error'])) {
$result['msg'] .= "{$lsphp_binary} exists, but not runnable: {$ls_php['error']} \n";
return $result;
}
$result['msg'] .= "Found LiteSpeed PHP binary at {$lsphp_binary}. Version is {$ls_php['PHP_VERSION']} \n";
if ( $apache_php['PHP_VERSION'] != $ls_php['PHP_VERSION'] ) {
$result['msg'] .= "PHP binary has different version! \n";
return $result;
}
//compare conf
$apache_options = preg_split("/[' ]/", $apache_php['PHP_CONF_OPTIONS'], -1, PREG_SPLIT_NO_EMPTY);
$ls_options = preg_split("/[' ]/", $ls_php['PHP_CONF_OPTIONS'], -1, PREG_SPLIT_NO_EMPTY);
$conf_diff = '';
foreach( $apache_options as $ai) {
if (!in_array($ai, $ls_options)) {
$conf_diff .= " $ai";
}
}
if ($conf_diff == '') {
$result['msg'] .= "Configuration options for lsphp and Apache PHP are matched.\n";
$result['next'] = 0; // same, no action needed.
return $result;
}
else {
$result['msg'] .= "Apache PHP configuration has more options that are not available or different in lsphp: $conf_diff \n";
return $result;
}
}
}
modlscapi/buildlsphp/php.ini 0000644 00000112315 15252655706 0012175 0 ustar 00 [PHP]
;;;;;;;;;;;
; WARNING ;
;;;;;;;;;;;
; This is the default settings file for new PHP installations.
; By default, PHP installs itself with a configuration suitable for
; development purposes, and *NOT* for production purposes.
; For several security-oriented considerations that should be taken
; before going online with your site, please consult php.ini-recommended
; and http://php.net/manual/en/security.php.
;;;;;;;;;;;;;;;;;;;
; About this file ;
;;;;;;;;;;;;;;;;;;;
; This file controls many aspects of PHP's behavior. In order for PHP to
; read it, it must be named 'php.ini'. PHP looks for it in the current
; working directory, in the path designated by the environment variable
; PHPRC, and in the path that was defined in compile time (in that order).
; Under Windows, the compile-time path is the Windows directory. The
; path in which the php.ini file is looked for can be overridden using
; the -c argument in command line mode.
;
; The syntax of the file is extremely simple. Whitespace and Lines
; beginning with a semicolon are silently ignored (as you probably guessed).
; Section headers (e.g. [Foo]) are also silently ignored, even though
; they might mean something in the future.
;
; Directives are specified using the following syntax:
; directive = value
; Directive names are *case sensitive* - foo=bar is different from FOO=bar.
;
; The value can be a string, a number, a PHP constant (e.g. E_ALL or M_PI), one
; of the INI constants (On, Off, True, False, Yes, No and None) or an expression
; (e.g. E_ALL & ~E_NOTICE), or a quoted string ("foo").
;
; Expressions in the INI file are limited to bitwise operators and parentheses:
; | bitwise OR
; & bitwise AND
; ~ bitwise NOT
; ! boolean NOT
;
; Boolean flags can be turned on using the values 1, On, True or Yes.
; They can be turned off using the values 0, Off, False or No.
;
; An empty string can be denoted by simply not writing anything after the equal
; sign, or by using the None keyword:
;
; foo = ; sets foo to an empty string
; foo = none ; sets foo to an empty string
; foo = "none" ; sets foo to the string 'none'
;
; If you use constants in your value, and these constants belong to a
; dynamically loaded extension (either a PHP extension or a Zend extension),
; you may only use these constants *after* the line that loads the extension.
;
; All the values in the php.ini-dist file correspond to the builtin
; defaults (that is, if no php.ini is used, or if you delete these lines,
; the builtin defaults will be identical).
;;;;;;;;;;;;;;;;;;;;
; Language Options ;
;;;;;;;;;;;;;;;;;;;;
; Enable the PHP scripting language engine under Apache.
engine = On
; Allow the tag. Otherwise, only tags are recognized.
; NOTE: Using short tags should be avoided when developing applications or
; libraries that are meant for redistribution, or deployment on PHP
; servers which are not under your control, because short tags may not
; be supported on the target server. For portable, redistributable code,
; be sure not to use short tags.
short_open_tag = On
; Allow ASP-style <% %> tags.
asp_tags = Off
; The number of significant digits displayed in floating point numbers.
precision = 12
; Enforce year 2000 compliance (will cause problems with non-compliant browsers)
;y2k_compliance = On
; Output buffering allows you to send header lines (including cookies) even
; after you send body content, at the price of slowing PHP's output layer a
; bit. You can enable output buffering during runtime by calling the output
; buffering functions. You can also enable output buffering for all files by
; setting this directive to On. If you wish to limit the size of the buffer
; to a certain size - you can use a maximum number of bytes instead of 'On', as
; a value for this directive (e.g., output_buffering=4096).
output_buffering = Off
; You can redirect all of the output of your scripts to a function. For
; example, if you set output_handler to "mb_output_handler", character
; encoding will be transparently converted to the specified encoding.
; Setting any output handler automatically turns on output buffering.
; Note: People who wrote portable scripts should not depend on this ini
; directive. Instead, explicitly set the output handler using ob_start().
; Using this ini directive may cause problems unless you know what script
; is doing.
; Note: You cannot use both "mb_output_handler" with "ob_iconv_handler"
; and you cannot use both "ob_gzhandler" and "zlib.output_compression".
;output_handler =
; Transparent output compression using the zlib library
; Valid values for this option are 'off', 'on', or a specific buffer size
; to be used for compression (default is 4KB)
; Note: Resulting chunk size may vary due to nature of compression. PHP
; outputs chunks that are few hundreds bytes each as a result of
; compression. If you prefer a larger chunk size for better
; performance, enable output_buffering in addition.
; Note: You need to use zlib.output_handler instead of the standard
; output_handler, or otherwise the output will be corrupted.
zlib.output_compression = Off
; You cannot specify additional output handlers if zlib.output_compression
; is activated here. This setting does the same as output_handler but in
; a different order.
;zlib.output_handler =
; Implicit flush tells PHP to tell the output layer to flush itself
; automatically after every output block. This is equivalent to calling the
; PHP function flush() after each and every call to print() or echo() and each
; and every HTML block. Turning this option on has serious performance
; implications and is generally recommended for debugging purposes only.
implicit_flush = Off
; The unserialize callback function will be called (with the undefined class'
; name as parameter), if the unserializer finds an undefined class
; which should be instanciated.
; A warning appears if the specified function is not defined, or if the
; function doesn't include/implement the missing class.
; So only set this entry, if you really want to implement such a
; callback-function.
unserialize_callback_func=
; When floats & doubles are serialized store serialize_precision significant
; digits after the floating point. The default value ensures that when floats
; are decoded with unserialize, the data will remain the same.
serialize_precision = 100
; Safe Mode
;
safe_mode = Off
; By default, Safe Mode does a UID compare check when
; opening files. If you want to relax this to a GID compare,
; then turn on safe_mode_gid.
safe_mode_gid = Off
; When safe_mode is on, UID/GID checks are bypassed when
; including files from this directory and its subdirectories.
; (directory must also be in include_path or full path must
; be used when including)
;safe_mode_include_dir =
; When safe_mode is on, only executables located in the safe_mode_exec_dir
; will be allowed to be executed via the exec family of functions.
;safe_mode_exec_dir =
; Setting certain environment variables may be a potential security breach.
; This directive contains a comma-delimited list of prefixes. In Safe Mode,
; the user may only alter environment variables whose names begin with the
; prefixes supplied here. By default, users will only be able to set
; environment variables that begin with PHP_ (e.g. PHP_FOO=BAR).
;
; Note: If this directive is empty, PHP will let the user modify ANY
; environment variable!
;safe_mode_allowed_env_vars = PHP_
; This directive contains a comma-delimited list of environment variables that
; the end user won't be able to change using putenv(). These variables will be
; protected even if safe_mode_allowed_env_vars is set to allow to change them.
;safe_mode_protected_env_vars = LD_LIBRARY_PATH
; open_basedir, if set, limits all file operations to the defined directory
; and below. This directive makes most sense if used in a per-directory
; or per-virtualhost web server configuration file. This directive is
; *NOT* affected by whether Safe Mode is turned On or Off.
;open_basedir =
; This directive allows you to disable certain functions for security reasons.
; It receives a comma-delimited list of function names. This directive is
; *NOT* affected by whether Safe Mode is turned On or Off.
disable_functions =
; This directive allows you to disable certain classes for security reasons.
; It receives a comma-delimited list of class names. This directive is
; *NOT* affected by whether Safe Mode is turned On or Off.
disable_classes =
; Colors for Syntax Highlighting mode. Anything that's acceptable in
; would work.
;highlight.string = #DD0000
;highlight.comment = #FF9900
;highlight.keyword = #007700
;highlight.bg = #FFFFFF
;highlight.default = #0000BB
;highlight.html = #000000
;
; Misc
;
; Decides whether PHP may expose the fact that it is installed on the server
; (e.g. by adding its signature to the Web server header). It is no security
; threat in any way, but it makes it possible to determine whether you use PHP
; on your server or not.
expose_php = On
;;;;;;;;;;;;;;;;;;;
; Resource Limits ;
;;;;;;;;;;;;;;;;;;;
max_execution_time = 30 ; Maximum execution time of each script, in seconds
max_input_time = 60 ; Maximum amount of time each script may spend parsing request data
max_input_vars = 1000
memory_limit = 32M ; Maximum amount of memory a script may consume (32MB)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Error handling and logging ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; error_reporting is a bit-field. Or each number up to get desired error
; reporting level
; E_ALL - All errors and warnings
; E_ERROR - fatal run-time errors
; E_WARNING - run-time warnings (non-fatal errors)
; E_PARSE - compile-time parse errors
; E_NOTICE - run-time notices (these are warnings which often result
; from a bug in your code, but it's possible that it was
; intentional (e.g., using an uninitialized variable and
; relying on the fact it's automatically initialized to an
; empty string)
; E_CORE_ERROR - fatal errors that occur during PHP's initial startup
; E_CORE_WARNING - warnings (non-fatal errors) that occur during PHP's
; initial startup
; E_COMPILE_ERROR - fatal compile-time errors
; E_COMPILE_WARNING - compile-time warnings (non-fatal errors)
; E_USER_ERROR - user-generated error message
; E_USER_WARNING - user-generated warning message
; E_USER_NOTICE - user-generated notice message
;
; Examples:
;
; - Show all errors, except for notices
;
;error_reporting = E_ALL & ~E_NOTICE
;
; - Show only errors
;
;error_reporting = E_COMPILE_ERROR|E_ERROR|E_CORE_ERROR
;
; - Show all errors except for notices
;
error_reporting = E_ALL & ~E_NOTICE & ~E_DEPRECATED
; Print out errors (as a part of the output). For production web sites,
; you're strongly encouraged to turn this feature off, and use error logging
; instead (see below). Keeping display_errors enabled on a production web site
; may reveal security information to end users, such as file paths on your Web
; server, your database schema or other information.
display_errors = On
; Even when display_errors is on, errors that occur during PHP's startup
; sequence are not displayed. It's strongly recommended to keep
; display_startup_errors off, except for when debugging.
display_startup_errors = Off
; Log errors into a log file (server-specific log, stderr, or error_log (below))
; As stated above, you're strongly advised to use error logging in place of
; error displaying on production web sites.
log_errors = On
; Set maximum length of log_errors. In error_log information about the source is
; added. The default is 1024 and 0 allows to not apply any maximum length at all.
log_errors_max_len = 1024
; Do not log repeated messages. Repeated errors must occur in same file on same
; line until ignore_repeated_source is set true.
ignore_repeated_errors = Off
; Ignore source of message when ignoring repeated messages. When this setting
; is On you will not log errors with repeated messages from different files or
; sourcelines.
ignore_repeated_source = Off
; If this parameter is set to Off, then memory leaks will not be shown (on
; stdout or in the log). This has only effect in a debug compile, and if
; error reporting includes E_WARNING in the allowed list
report_memleaks = On
; Store the last error/warning message in $php_errormsg (boolean).
track_errors = Off
; Disable the inclusion of HTML tags in error messages.
;html_errors = Off
; If html_errors is set On PHP produces clickable error messages that direct
; to a page describing the error or function causing the error in detail.
; You can download a copy of the PHP manual from http://www.php.net/docs.php
; and change docref_root to the base URL of your local copy including the
; leading '/'. You must also specify the file extension being used including
; the dot.
;docref_root = "/phpmanual/"
;docref_ext = .html
; String to output before an error message.
;error_prepend_string = ""
; String to output after an error message.
;error_append_string = ""
; Log errors to specified file.
error_log = error_log
; Log errors to syslog (Event Log on NT, not valid in Windows 95).
;error_log = syslog
;;;;;;;;;;;;;;;;;
; Data Handling ;
;;;;;;;;;;;;;;;;;
;
; Note - track_vars is ALWAYS enabled as of PHP 4.0.3
; The separator used in PHP generated URLs to separate arguments.
; Default is "&".
;arg_separator.output = "&"
; List of separator(s) used by PHP to parse input URLs into variables.
; Default is "&".
; NOTE: Every character in this directive is considered as separator!
;arg_separator.input = ";&"
; This directive describes the order in which PHP registers GET, POST, Cookie,
; Environment and Built-in variables (G, P, C, E & S respectively, often
; referred to as EGPCS or GPC). Registration is done from left to right, newer
; values override older values.
variables_order = "EGPCS"
; Whether or not to register the EGPCS variables as global variables. You may
; want to turn this off if you don't want to clutter your scripts' global scope
; with user data. This makes most sense when coupled with track_vars - in which
; case you can access all of the GPC variables through the $HTTP_*_VARS[],
; variables.
;
; You should do your best to write your scripts so that they do not require
; register_globals to be on; Using form variables as globals can easily lead
; to possible security problems, if the code is not very well thought of.
;register_globals = Off
; This directive tells PHP whether to declare the argv&argc variables (that
; would contain the GET information). If you don't use these variables, you
; should turn it off for increased performance.
register_argc_argv = On
; Maximum size of POST data that PHP will accept.
post_max_size = 8M
; This directive is deprecated. Use variables_order instead.
gpc_order = "GPC"
; Magic quotes
;
; Magic quotes for incoming GET/POST/Cookie data.
;magic_quotes_gpc = Off
; Magic quotes for runtime-generated data, e.g. data from SQL, from exec(), etc.
;magic_quotes_runtime = Off
; Use Sybase-style magic quotes (escape ' with '' instead of \').
;magic_quotes_sybase = Off
; Automatically add files before or after any PHP document.
auto_prepend_file =
auto_append_file =
; As of 4.0b4, PHP always outputs a character encoding by default in
; the Content-type: header. To disable sending of the charset, simply
; set it to be empty.
;
; PHP's built-in default is text/html
default_mimetype = "text/html"
;default_charset = "iso-8859-1"
; Always populate the $HTTP_RAW_POST_DATA variable.
;always_populate_raw_post_data = On
;;;;;;;;;;;;;;;;;;;;;;;;;
; Paths and Directories ;
;;;;;;;;;;;;;;;;;;;;;;;;;
; UNIX: "/path1:/path2"
include_path = ".:/usr/lib/php:/usr/local/lib/php"
;
; Windows: "\path1;\path2"
;include_path = ".;c:\php\includes"
; The root of the PHP pages, used only if nonempty.
; if PHP was not compiled with FORCE_REDIRECT, you SHOULD set doc_root
; if you are running php as a CGI under any web server (other than IIS)
; see documentation for security issues. The alternate is to use the
; cgi.force_redirect configuration below
doc_root =
; The directory under which PHP opens the script using /~username used only
; if nonempty.
user_dir =
; Directory in which the loadable extensions (modules) reside.
;extension_dir = "/usr/local/lib/php/extensions/no-debug-non-zts-20100525"
; Whether or not to enable the dl() function. The dl() function does NOT work
; properly in multithreaded servers, such as IIS or Zeus, and is automatically
; disabled on them.
enable_dl = On
; cgi.force_redirect is necessary to provide security running PHP as a CGI under
; most web servers. Left undefined, PHP turns this on by default. You can
; turn it off here AT YOUR OWN RISK
; **You CAN safely turn this off for IIS, in fact, you MUST.**
; cgi.force_redirect = 1
; if cgi.nph is enabled it will force cgi to always sent Status: 200 with
; every request.
; cgi.nph = 1
; if cgi.force_redirect is turned on, and you are not running under Apache or Netscape
; (iPlanet) web servers, you MAY need to set an environment variable name that PHP
; will look for to know it is OK to continue execution. Setting this variable MAY
; cause security issues, KNOW WHAT YOU ARE DOING FIRST.
; cgi.redirect_status_env = ;
; cgi.fix_pathinfo provides *real* PATH_INFO/PATH_TRANSLATED support for CGI. PHP's
; previous behaviour was to set PATH_TRANSLATED to SCRIPT_FILENAME, and to not grok
; what PATH_INFO is. For more information on PATH_INFO, see the cgi specs. Setting
; this to 1 will cause PHP CGI to fix it's paths to conform to the spec. A setting
; of zero causes PHP to behave as before. Default is zero. You should fix your scripts
; to use SCRIPT_FILENAME rather than PATH_TRANSLATED.
; cgi.fix_pathinfo=0
; FastCGI under IIS (on WINNT based OS) supports the ability to impersonate
; security tokens of the calling client. This allows IIS to define the
; security context that the request runs under. mod_fastcgi under Apache
; does not currently support this feature (03/17/2002)
; Set to 1 if running under IIS. Default is zero.
; fastcgi.impersonate = 1;
; cgi.rfc2616_headers configuration option tells PHP what type of headers to
; use when sending HTTP response code. If it's set 0 PHP sends Status: header that
; is supported by Apache. When this option is set to 1 PHP will send
; RFC2616 compliant header.
; Default is zero.
;cgi.rfc2616_headers = 0
;;;;;;;;;;;;;;;;
; File Uploads ;
;;;;;;;;;;;;;;;;
; Whether to allow HTTP file uploads.
file_uploads = On
; Temporary directory for HTTP uploaded files (will use system default if not
; specified).
;upload_tmp_dir =
; Maximum allowed size for uploaded files.
upload_max_filesize = 2M
;;;;;;;;;;;;;;;;;;
; Fopen wrappers ;
;;;;;;;;;;;;;;;;;;
; Whether to allow the treatment of URLs (like http:// or ftp://) as files.
allow_url_fopen = On
; Define the anonymous ftp password (your email address)
;from="john@doe.com"
; Define the User-Agent string
; user_agent="PHP"
; Default timeout for socket based streams (seconds)
default_socket_timeout = 60
; If your scripts have to deal with files from Macintosh systems,
; or you are running on a Mac and need to deal with files from
; unix or win32 systems, setting this flag will cause PHP to
; automatically detect the EOL character in those files so that
; fgets() and file() will work regardless of the source of the file.
; auto_detect_line_endings = Off
;;;;;;;;;;;;;;;;;;;;;;
; Dynamic Extensions ;
;;;;;;;;;;;;;;;;;;;;;;
;
; If you wish to have an extension loaded automatically, use the following
; syntax:
;
; extension=modulename.extension
;
; For example, on Windows:
;
; extension=msql.dll
;
; ... or under UNIX:
;
; extension=msql.so
;
; Note that it should be the name of the module only; no directory information
; needs to go here. Specify the location of the extension with the
; extension_dir directive above.
;Windows Extensions
;Note that MySQL and ODBC support is now built in, so no dll is needed for it.
;
;extension=php_bz2.dll
;extension=php_cpdf.dll
;extension=php_crack.dll
;extension=php_curl.dll
;extension=php_db.dll
;extension=php_dba.dll
;extension=php_dbase.dll
;extension=php_dbx.dll
;extension=php_domxml.dll
;extension=php_exif.dll
;extension=php_fdf.dll
;extension=php_filepro.dll
;extension=php_gd2.dll
;extension=php_gettext.dll
;extension=php_hyperwave.dll
;extension=php_iconv.dll
;extension=php_ifx.dll
;extension=php_iisfunc.dll
;extension=php_imap.dll
;extension=php_interbase.dll
;extension=php_java.dll
;extension=php_ldap.dll
;extension=php_mbstring.dll
;extension=php_mcrypt.dll
;extension=php_mhash.dll
;extension=php_mime_magic.dll
;extension=php_ming.dll
;extension=php_mssql.dll
;extension=php_msql.dll
;extension=php_oci8.dll
;extension=php_openssl.dll
;extension=php_oracle.dll
;extension=php_pdf.dll
;extension=php_pgsql.dll
;extension=php_printer.dll
;extension=php_shmop.dll
;extension=php_snmp.dll
;extension=php_sockets.dll
;extension=php_sybase_ct.dll
;extension=php_w32api.dll
;extension=php_xmlrpc.dll
;extension=php_xslt.dll
;extension=php_yaz.dll
;extension=php_zip.dll
;;;;;;;;;;;;;;;;;;;
; Module Settings ;
;;;;;;;;;;;;;;;;;;;
[Syslog]
; Whether or not to define the various syslog variables (e.g. $LOG_PID,
; $LOG_CRON, etc.). Turning it off is a good idea performance-wise. In
; runtime, you can define these variables by calling define_syslog_variables().
;define_syslog_variables = Off
[mail function]
; For Win32 only.
;SMTP = localhost
smtp_port = 25
; For Win32 only.
;sendmail_from = me@localhost.com
; For Unix only. You may supply arguments as well (default: "sendmail -t -i").
sendmail_path = "/usr/sbin/sendmail -t -i"
[Java]
;java.class.path = .\php_java.jar
;java.home = c:\jdk
;java.library = c:\jdk\jre\bin\hotspot\jvm.dll
;java.library.path = .\
[SQL]
sql.safe_mode = Off
[ODBC]
;odbc.default_db = Not yet implemented
;odbc.default_user = Not yet implemented
;odbc.default_pw = Not yet implemented
; Allow or prevent persistent links.
odbc.allow_persistent = On
; Check that a connection is still valid before reuse.
odbc.check_persistent = On
; Maximum number of persistent links. -1 means no limit.
odbc.max_persistent = -1
; Maximum number of links (persistent + non-persistent). -1 means no limit.
odbc.max_links = -1
; Handling of LONG fields. Returns number of bytes to variables. 0 means
; passthru.
odbc.defaultlrl = 4096
; Handling of binary data. 0 means passthru, 1 return as is, 2 convert to char.
; See the documentation on odbc_binmode and odbc_longreadlen for an explanation
; of uodbc.defaultlrl and uodbc.defaultbinmode
odbc.defaultbinmode = 1
[MySQL]
; Allow or prevent persistent links.
mysql.allow_persistent = On
; Maximum number of persistent links. -1 means no limit.
mysql.max_persistent = -1
; Maximum number of links (persistent + non-persistent). -1 means no limit.
mysql.max_links = -1
; Default port number for mysql_connect(). If unset, mysql_connect() will use
; the $MYSQL_TCP_PORT or the mysql-tcp entry in /etc/services or the
; compile-time value defined MYSQL_PORT (in that order). Win32 will only look
; at MYSQL_PORT.
mysql.default_port =
; Default socket name for local MySQL connects. If empty, uses the built-in
; MySQL defaults.
mysql.default_socket =
; Default host for mysql_connect() (doesn't apply in safe mode).
mysql.default_host =
; Default user for mysql_connect() (doesn't apply in safe mode).
mysql.default_user =
; Default password for mysql_connect() (doesn't apply in safe mode).
; Note that this is generally a *bad* idea to store passwords in this file.
; *Any* user with PHP access can run 'echo get_cfg_var("mysql.default_password")
; and reveal this password! And of course, any users with read access to this
; file will be able to reveal the password as well.
mysql.default_password =
; Maximum time (in seconds) for connect timeout. -1 means no limit
mysql.connect_timeout = 60
; Trace mode. When trace_mode is active (=On), warnings for table/index scans and
; SQL-Errors will be displayed.
mysql.trace_mode = Off
[mSQL]
; Allow or prevent persistent links.
msql.allow_persistent = On
; Maximum number of persistent links. -1 means no limit.
msql.max_persistent = -1
; Maximum number of links (persistent+non persistent). -1 means no limit.
msql.max_links = -1
[PostgresSQL]
; Allow or prevent persistent links.
pgsql.allow_persistent = On
; Detect broken persistent links always with pg_pconnect(). Need a little overhead.
pgsql.auto_reset_persistent = Off
; Maximum number of persistent links. -1 means no limit.
pgsql.max_persistent = -1
; Maximum number of links (persistent+non persistent). -1 means no limit.
pgsql.max_links = -1
; Ignore PostgreSQL backends Notice message or not.
pgsql.ignore_notice = 0
; Log PostgreSQL backends Noitce message or not.
; Unless pgsql.ignore_notice=0, module cannot log notice message.
pgsql.log_notice = 0
[Sybase]
; Allow or prevent persistent links.
sybase.allow_persistent = On
; Maximum number of persistent links. -1 means no limit.
sybase.max_persistent = -1
; Maximum number of links (persistent + non-persistent). -1 means no limit.
sybase.max_links = -1
;sybase.interface_file = "/usr/sybase/interfaces"
; Minimum error severity to display.
sybase.min_error_severity = 10
; Minimum message severity to display.
sybase.min_message_severity = 10
; Compatability mode with old versions of PHP 3.0.
; If on, this will cause PHP to automatically assign types to results according
; to their Sybase type, instead of treating them all as strings. This
; compatibility mode will probably not stay around forever, so try applying
; whatever necessary changes to your code, and turn it off.
sybase.compatability_mode = Off
[Sybase-CT]
; Allow or prevent persistent links.
sybct.allow_persistent = On
; Maximum number of persistent links. -1 means no limit.
sybct.max_persistent = -1
; Maximum number of links (persistent + non-persistent). -1 means no limit.
sybct.max_links = -1
; Minimum server message severity to display.
sybct.min_server_severity = 10
; Minimum client message severity to display.
sybct.min_client_severity = 10
[dbx]
; returned column names can be converted for compatibility reasons
; possible values for dbx.colnames_case are
; "unchanged" (default, if not set)
; "lowercase"
; "uppercase"
; the recommended default is either upper- or lowercase, but
; unchanged is currently set for backwards compatibility
dbx.colnames_case = "unchanged"
[bcmath]
; Number of decimal digits for all bcmath functions.
bcmath.scale = 0
[browscap]
;browscap = extra/browscap.ini
[Informix]
; Default host for ifx_connect() (doesn't apply in safe mode).
ifx.default_host =
; Default user for ifx_connect() (doesn't apply in safe mode).
ifx.default_user =
; Default password for ifx_connect() (doesn't apply in safe mode).
ifx.default_password =
; Allow or prevent persistent links.
ifx.allow_persistent = On
; Maximum number of persistent links. -1 means no limit.
ifx.max_persistent = -1
; Maximum number of links (persistent + non-persistent). -1 means no limit.
ifx.max_links = -1
; If on, select statements return the contents of a text blob instead of its id.
ifx.textasvarchar = 0
; If on, select statements return the contents of a byte blob instead of its id.
ifx.byteasvarchar = 0
; Trailing blanks are stripped from fixed-length char columns. May help the
; life of Informix SE users.
ifx.charasvarchar = 0
; If on, the contents of text and byte blobs are dumped to a file instead of
; keeping them in memory.
ifx.blobinfile = 0
; NULL's are returned as empty strings, unless this is set to 1. In that case,
; NULL's are returned as string 'NULL'.
ifx.nullformat = 0
[Session]
; Handler used to store/retrieve data.
session.save_handler = files
; Argument passed to save_handler. In the case of files, this is the path
; where data files are stored. Note: Windows users have to change this
; variable in order to use PHP's session functions.
; As of PHP 4.0.1, you can define the path as: session.save_path = "N;/path"
; where N is an integer. Instead of storing all the session files in
; /path, what this will do is use subdirectories N-levels deep, and
; store the session data in those directories. This is useful if you
; or your OS have problems with lots of files in one directory, and is
; a more efficient layout for servers that handle lots of sessions.
; NOTE 1: PHP will not create this directory structure automatically.
; You can use the script in the ext/session dir for that purpose.
; NOTE 2: See the section on garbage collection below if you choose to
; use subdirectories for session storage
session.save_path = /tmp
; Whether to use cookies.
session.use_cookies = 1
; This option enables administrators to make their users invulnerable to
; attacks which involve passing session ids in URLs; defaults to 0.
; session.use_only_cookies = 1
; Name of the session (used as cookie name).
session.name = PHPSESSID
; Initialize session on request startup.
session.auto_start = 0
; Lifetime in seconds of cookie or, if 0, until browser is restarted.
session.cookie_lifetime = 0
; The path for which the cookie is valid.
session.cookie_path = /
; The domain for which the cookie is valid.
session.cookie_domain =
; Handler used to serialize data. php is the standard serializer of PHP.
session.serialize_handler = php
; Define the probability that the 'garbage collection' process is started
; on every session initialization.
; The probability is calculated by using gc_probability/gc_divisor,
; e.g. 1/100 means there is a 1% chance that the GC process starts
; on each request.
session.gc_probability = 1
session.gc_divisor = 100
; After this number of seconds, stored data will be seen as 'garbage' and
; cleaned up by the garbage collection process.
session.gc_maxlifetime = 1440
; NOTE: If you are using the subdirectory option for storing session files
; (see session.save_path above), then garbage collection does *not*
; happen automatically. You will need to do your own garbage
; collection through a shell script, cron entry, or some other method.
; For example, the following script would is the equivalent of
; setting session.gc_maxlifetime to 1440 (1440 seconds = 24 minutes):
; cd /path/to/sessions; find -cmin +24 | xargs rm
; PHP 4.2 and less have an undocumented feature/bug that allows you to
; to initialize a session variable in the global scope, albeit register_globals
; is disabled. PHP 4.3 and later will warn you, if this feature is used.
; You can disable the feature and the warning separately. At this time,
; the warning is only displayed, if bug_compat_42 is enabled.
;session.bug_compat_42 = 1
;session.bug_compat_warn = 1
; Check HTTP Referer to invalidate externally stored URLs containing ids.
; HTTP_REFERER has to contain this substring for the session to be
; considered as valid.
session.referer_check =
; How many bytes to read from the file.
session.entropy_length = 0
; Specified here to create the session id.
session.entropy_file =
;session.entropy_length = 16
;session.entropy_file = /dev/urandom
; Set to {nocache,private,public,} to determine HTTP caching aspects
; or leave this empty to avoid sending anti-caching headers.
session.cache_limiter = nocache
; Document expires after n minutes.
session.cache_expire = 180
; trans sid support is disabled by default.
; Use of trans sid may risk your users security.
; Use this option with caution.
; - User may send URL contains active session ID
; to other person via. email/irc/etc.
; - URL that contains active session ID may be stored
; in publically accessible computer.
; - User may access your site with the same session ID
; always using URL stored in browser's history or bookmarks.
session.use_trans_sid = 0
; The URL rewriter will look for URLs in a defined set of HTML tags.
; form/fieldset are special; if you include them here, the rewriter will
; add a hidden field with the info which is otherwise appended
; to URLs. If you want XHTML conformity, remove the form entry.
; Note that all valid entries require a "=", even if no value follows.
url_rewriter.tags = "a=href,area=href,frame=src,input=src,form=,fieldset="
[MSSQL]
; Allow or prevent persistent links.
mssql.allow_persistent = On
; Maximum number of persistent links. -1 means no limit.
mssql.max_persistent = -1
; Maximum number of links (persistent+non persistent). -1 means no limit.
mssql.max_links = -1
; Minimum error severity to display.
mssql.min_error_severity = 10
; Minimum message severity to display.
mssql.min_message_severity = 10
; Compatability mode with old versions of PHP 3.0.
mssql.compatability_mode = Off
; Connect timeout
;mssql.connect_timeout = 5
; Query timeout
;mssql.timeout = 60
; Valid range 0 - 2147483647. Default = 4096.
;mssql.textlimit = 4096
; Valid range 0 - 2147483647. Default = 4096.
;mssql.textsize = 4096
; Limits the number of records in each batch. 0 = all records in one batch.
;mssql.batchsize = 0
; Specify how datetime and datetim4 columns are returned
; On => Returns data converted to SQL server settings
; Off => Returns values as YYYY-MM-DD hh:mm:ss
;mssql.datetimeconvert = On
; Use NT authentication when connecting to the server
mssql.secure_connection = Off
; Specify max number of processes. Default = 25
;mssql.max_procs = 25
[Assertion]
; Assert(expr); active by default.
;assert.active = On
; Issue a PHP warning for each failed assertion.
;assert.warning = On
; Don't bail out by default.
;assert.bail = Off
; User-function to be called if an assertion fails.
;assert.callback = 0
; Eval the expression with current error_reporting(). Set to true if you want
; error_reporting(0) around the eval().
;assert.quiet_eval = 0
[Ingres II]
; Allow or prevent persistent links.
ingres.allow_persistent = On
; Maximum number of persistent links. -1 means no limit.
ingres.max_persistent = -1
; Maximum number of links, including persistents. -1 means no limit.
ingres.max_links = -1
; Default database (format: [node_id::]dbname[/srv_class]).
ingres.default_database =
; Default user.
ingres.default_user =
; Default password.
ingres.default_password =
[Verisign Payflow Pro]
; Default Payflow Pro server.
pfpro.defaulthost = "test-payflow.verisign.com"
; Default port to connect to.
pfpro.defaultport = 443
; Default timeout in seconds.
pfpro.defaulttimeout = 30
; Default proxy IP address (if required).
;pfpro.proxyaddress =
; Default proxy port.
;pfpro.proxyport =
; Default proxy logon.
;pfpro.proxylogon =
; Default proxy password.
;pfpro.proxypassword =
[com]
; path to a file containing GUIDs, IIDs or filenames of files with TypeLibs
;com.typelib_file =
; allow Distributed-COM calls
;com.allow_dcom = true
; autoregister constants of a components typlib on com_load()
;com.autoregister_typelib = true
; register constants casesensitive
;com.autoregister_casesensitive = false
; show warnings on duplicate constat registrations
;com.autoregister_verbose = true
[Printer]
;printer.default_printer = ""
[mbstring]
; language for internal character representation.
;mbstring.language = Japanese
; internal/script encoding.
; Some encoding cannot work as internal encoding.
; (e.g. SJIS, BIG5, ISO-2022-*)
;mbstring.internal_encoding = EUC-JP
; http input encoding.
;mbstring.http_input = auto
; http output encoding. mb_output_handler must be
; registered as output buffer to function
;mbstring.http_output = SJIS
; enable automatic encoding translation accoding to
; mbstring.internal_encoding setting. Input chars are
; converted to internal encoding by setting this to On.
; Note: Do _not_ use automatic encoding translation for
; portable libs/applications.
;mbstring.encoding_translation = Off
; automatic encoding detection order.
; auto means
;mbstring.detect_order = auto
; substitute_character used when character cannot be converted
; one from another
;mbstring.substitute_character = none;
; overload(replace) single byte functions by mbstring functions.
; mail(), ereg(), etc are overloaded by mb_send_mail(), mb_ereg(),
; etc. Possible values are 0,1,2,4 or combination of them.
; For example, 7 for overload everything.
; 0: No overload
; 1: Overload mail() function
; 2: Overload str*() functions
; 4: Overload ereg*() functions
;mbstring.func_overload = 0
[FrontBase]
;fbsql.allow_persistent = On
;fbsql.autocommit = On
;fbsql.default_database =
;fbsql.default_database_password =
;fbsql.default_host =
;fbsql.default_password =
;fbsql.default_user = "_SYSTEM"
;fbsql.generate_warnings = Off
;fbsql.max_connections = 128
;fbsql.max_links = 128
;fbsql.max_persistent = -1
;fbsql.max_results = 128
;fbsql.batchSize = 1000
[Crack]
; Modify the setting below to match the directory location of the cracklib
; dictionary files. Include the base filename, but not the file extension.
; crack.default_dictionary = "c:\php\lib\cracklib_dict"
[exif]
; Exif UNICODE user comments are handled as UCS-2BE/UCS-2LE and JIS as JIS.
; With mbstring support this will automatically be converted into the encoding
; given by corresponding encode setting. When empty mbstring.internal_encoding
; is used. For the decode settings you can distinguish between motorola and
; intel byte order. A decode setting cannot be empty.
;exif.encode_unicode = ISO-8859-15
;exif.decode_unicode_motorola = UCS-2BE
;exif.decode_unicode_intel = UCS-2LE
;exif.encode_jis =
;exif.decode_jis_motorola = JIS
;exif.decode_jis_intel = JIS
; Local Variables:
; tab-width: 4
; End:
date.timezone="UTC"
modlscapi/buildlsphp/cmd_buildmatchingphp.php 0000644 00000004366 15252655706 0015571 0 ustar 00 PrecheckPHPVersion(PHP_AP_LOC, $msg);
echo "$msg \n";
// return 0: same, 1 different; 2 error stop;
$do_build = FALSE;
if ($next == 2) {
echo "Please make sure PHP exists, you can specify a different location by editing variable definition PHP_AP_LOC \n";
}
elseif (isset($argv[1]) && $argv[1] == '-v') {
echo "Verify only - Exit!\n";
}
elseif ($next == 0) {
if (isset($argv[1]) && $argv[1] == '-f') {
echo "Config option is same, will do force rebuild matching php";
$do_build = TRUE;
}
else {
echo "No need to rebuild. Aborted! If you want to do force rebuid, add parameter -f \n";
}
}
else { // next == 1
$do_build = TRUE;
}
if ((isset($argv[1])) && ($argv[1] != '-f') && ($argv[1] != '-v')) {
$path_to_bld = trim($argv[1]);
}
if (!$do_build)
exit;
echo "Next will build lsphp using the same configuration as Apache's php.
This will download the source code and build php binary. The whole process may take more than 10 minutes, please be patient.\n";
$curdir = getcwd();
if ($curdir != CGI_DIR) {
echo "change current directory to " . CGI_DIR . "\n";
chdir(CGI_DIR);
}
$result = $buildtool->GenerateBuildScript(PHP_AP_LOC, $path_to_bld);
if (isset($result['error'])) {
echo "{$result['error']} \n Aborted!\n";
return false;
}
$build_script = $result['file'];
echo "build script generated at $build_script \n";
system($build_script);
modlscapi/tmp/INFO 0000644 00000000013 15252655706 0010004 0 ustar 00 CloudLinux
modlscapi/user/stat_utils.py 0000644 00000022255 15252655706 0012265 0 ustar 00 # Copyright (c) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2018 All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
import string
import sys
import os
import traceback
import json
import configparser
from io import StringIO
from pipes import quote
import exec_command
class StatUtilsException(Exception):
pass
def cpanel_whmapi(cmd, **kwargs):
"""
Perform cPanel WHM API console request and return data from result
:param cmd: whm api command
:return: data dict from result
"""
joined_kwargs = ' '.join([quote('{0}={1}'.format(k, v)) for k, v in kwargs.items()])
result = exec_command.exec_command("/usr/sbin/whmapi1 {cmd} {kw} --output json".format(cmd=cmd, kw=joined_kwargs))
try:
dict_result = json.loads(''.join(result))
except ValueError:
# if result is not JSON
raise StatUtilsException(
"Failed to get JSON from this API request: {0} {1}; output: {2}".format(cmd,
joined_kwargs,
''.join(result)))
try:
return dict_result['data']
except KeyError:
# if there are no data field in received JSON
raise StatUtilsException("Failed to get data from this API result: {0}".format(dict_result))
def plesk_bin_php_handler(cmd, **kwargs):
"""
Perform Plesk php_handler utility console request and return result
:param cmd: php_handler command
:return: dict result
"""
# need to quote only value (-k 'v'), quoting full params ('-k v') causes API failure
joined_kwargs = ' '.join(['-{0} {1}'.format(k, quote(v)) for k, v in kwargs.items()])
result = exec_command.exec_command("/usr/local/psa/bin/php_handler --{cmd} {kw} -json true".format(cmd=cmd,
kw=joined_kwargs))
try:
return json.loads(''.join(result))
except ValueError:
raise StatUtilsException(
"Failed to get JSON from this API request: php_handler {0} {1}; output: {2}".format(cmd,
joined_kwargs,
''.join(result)))
def get_da_domains():
"""
Get domains per user
:return: dict(
user: list of domains
)
"""
da_users_path = '/usr/local/directadmin/data/users'
da_domains_path = '/usr/local/directadmin/data/users/{user}/domains.list'
da_users = os.listdir(da_users_path)
domains = dict.fromkeys(da_users)
try:
for user in da_users:
with open(da_domains_path.format(user=user), 'r') as domains_list_file:
domains[user] = set([l.strip() for l in domains_list_file.readlines()])
except (OSError, IOError):
raise StatUtilsException(''.join(traceback.format_exc().split('\n')))
return domains
def get_da_php_options():
"""
Get php settings from options.conf
:return: dict(
first php setting: {version, mode},
second php setting: {version, mode},
)
"""
options_path = '/usr/local/directadmin/custombuild/options.conf'
try:
config_parser, global_section = read_da_config(options_path)
php1_ver = config_parser.get(global_section, 'php1_release')
php2_ver = config_parser.get(global_section, 'php2_release')
php1_handler = config_parser.get(global_section, 'php1_mode')
php2_handler = config_parser.get(global_section, 'php2_mode')
except configparser.NoOptionError:
raise StatUtilsException('No option found: {0}'.format(''.join(traceback.format_exc().split('\n'))))
return {
1: {
'version': php1_ver,
'handler': 'lsapi' if php1_handler == 'lsphp' else php1_handler
},
2: {
'version': php2_ver,
'handler': 'lsapi' if php2_handler == 'lsphp' else php2_handler
}
}
def read_da_config(conf_file, append_section_name='dummy_section'):
"""
Read DA config file with ConfigParser.
Need to add dummy section for success
:param conf_file: config file name
:param append_section_name: name of section to place in the beginning of file
:return: RawConfigParser instance
"""
try:
with open(conf_file) as f:
file_content = StringIO('[{s}]\n'.format(s=append_section_name) + f.read())
config_parser = configparser.RawConfigParser(strict=False)
config_parser.read_file(file_content)
except (OSError, IOError):
raise StatUtilsException(''.join(traceback.format_exc().split('\n')))
return config_parser, append_section_name
def pretty_version_keys(php_ver, pre='php'):
"""
Convert simple php versions to pretty format
:param php_ver: {major}.{minor} version
:param pre: desired key start
:return: alt-php{major}{minor} or desired `pre`{major}{minor}
"""
template = '{0}%s%s'.format(pre)
try:
return template % tuple(php_ver.split('.'))
except Exception:
return php_ver
def dump_lsapi(ctl_path='/usr/sbin/httpd'):
"""
Get `httpd -t -D DUMP_RUN_LSAPI` info
For httpd24 this default path is `/opt/rh/httpd24/root/usr/sbin/httpd`, generated in make_from_templates.sh script
:param ctl_path: path to httpd (also apachectl may be used)
:return: dict(
lsapi_option: value
)
"""
apache_conf_data = exec_command.exec_command('{ctl} -t -D DUMP_RUN_LSAPI'.format(ctl=ctl_path))
try:
return dict([l.lower().split(' ') for l in apache_conf_data])
except:
return dict()
def dump_loaded_modules(ctl_path='/usr/sbin/httpd'):
"""
Get `httpd -M`
For httpd24 this default path is `/opt/rh/httpd24/root/usr/sbin/httpd`, generated in make_from_templates.sh script
:param ctl_path: path to httpd (also apachectl may be used)
:return: dict(
apache_module: value
)
"""
apache_modules = exec_command.exec_command('{ctl} -M'.format(ctl=ctl_path))
try:
return dict([l.lower().split(' ') for l in apache_modules])
except:
return dict()
def liblsapi_path():
"""
Retrieve path to liblsapi, depends on arch
:return: path to liblsapi
"""
is_64bits = sys.maxsize > 2**32
return '/usr/lib{a}/liblscapi.so'.format(a='64' if is_64bits else '')
def rpm_query(pkg):
"""
Get version-release from rpm -q `pkg`
:param pkg: package name to query
:return: version-release
"""
try:
ver, rel = ''.join(exec_command.exec_command('/bin/rpm -q ' + pkg + ' --qf %{v}-%{r}')).split('-')
return '{ver}-{rel}'.format(ver=ver, rel=rel.split('.')[0])
except ValueError:
return None
def query_strings(fname, template):
"""
Filter strings by given template
Also split string upon given template
:param fname: path to file
:param template: template to find in string
:return: first template occurrence splitted by template
"""
try:
return [l for l in strings(fname) if template in l][0].split(template)[1].strip()
except (IndexError, IOError, OSError):
return None
def strings(fname, n=6):
"""
Strings utility analog.
Finds printable strings in executable
:param fname: path to file
:param n: minimum string length
:return: generator, yeilds string
"""
with open(fname, errors='ignore') as f:
result = ""
for c in f.read():
if c in string.printable:
result += c
continue
if len(result) >= n:
yield result
result = ""
if len(result) >= n: # catch result at EOF
yield result
def count_domains(handler_struct, default_keys, only_lsapi=True):
"""
Count domains
:param handler_struct: handler: version: set_of_domains structure
:param default_keys: sequence of keys to add as default if no `lsapi` found
:param only_lsapi: return only lsapi statistics
:return: statistics - number of lsapi domains per version if only_lsapi=True
number of lsapi domains per version per handler otherwise
"""
result_stat = dict()
for h, data in handler_struct.items():
result_stat[h] = dict((k, len(v)) for k, v in data.items())
# if there are no lsapi handler domains, return 0 per each installed version
try:
return result_stat['lsapi'] if only_lsapi else result_stat
except KeyError:
return dict.fromkeys([x for x in default_keys if x != 'no'], 0)
modlscapi/user/exec_command.py 0000644 00000003176 15252655706 0012515 0 ustar 00 #%copyright%
import os
import subprocess
def first_quot(line, isquotf):
if line[0] == "\"" and isquotf == 0:
return 1
return 0
def last_quot(line, isquotf):
if line[len(line) - 1] == '\"' and isquotf == 1:
return 1
return 0
def parse_command(command):
command = command.split(" ")
isquot = 0
res = ""
result = []
for i in range(len(command)):
if command[i] != "":
if first_quot(command[i], isquot) == 1:
isquot = 1
res = command[i]
continue
if last_quot(command[i], isquot) == 1:
isquot = 0
res += " " + command[i]
result.append(res)
continue
result.append(command[i])
print(result)
def exec_command(command):
result = []
try:
p = subprocess.Popen(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
while 1:
output = p.stdout.readline()
if not output:
break
if output.strip() != "":
result.append(output.decode().strip())
except Exception as inst:
print("Call process error: " + str(inst))
return result
def exec_command_out(command):
"""
Run command via os.system and return its exit status
:param command: Command to execute in a subshell
:return: Exit status of the command process
"""
return os.system(command)
def exec_command_find_substring(command, substring):
result = exec_command(command)
for i in result:
if substring in i:
return i
return -1
modlscapi/user/selector_usage_lib.pyc 0000644 00000025741 15252655706 0014072 0 ustar 00
fc @ s d d l Z d d l Z d d l m Z d d l m Z d d l m Z m Z m Z d e
f d YZ d Z d Z
d Z d
Z d Z d Z d
Z d Z d Z d Z d Z d Z d Z d Z d Z d Z d S( iN( t etree( t deepcopy( t pretty_version_keyst
cpanel_whmapit dump_loaded_modulest SelectorStatExceptionc B s e Z d Z RS( s
Inner exception class
( t __name__t
__module__t __doc__( ( ( s3 /usr/share/lve/modlscapi/user/selector_usage_lib.pyR s c C s( d j t j d j } | d k S( s
Check status of cagefs - installed & enabled
If not - selector is not applied, no need to query its settings
:return: True is cagefs is installed and enabled, False otherwise
t s# /usr/sbin/cagefsctl --cagefs-statust Enabled( t joint exec_commandt strip( t
cagefs_status( ( s3 /usr/share/lve/modlscapi/user/selector_usage_lib.pyt cagefs_enabled s c c s d j t j d } y t j | j d } Wn t k
rM d } n Xx, | D]$ } | d } | d k rU | VqU qU Wd S( s`
Retrieve versions from selector, EXCEPT native
:return: selector versions iterator
R s% /usr/bin/selectorctl --summary --jsont PHPConfigurationt versiont nativeN( ( R R t jsont loadst gett
ValueError( t
selector_datat selector_versionst itemt ver( ( s3 /usr/share/lve/modlscapi/user/selector_usage_lib.pyt get_selector_versions s
c sG d j t j d j d } t f d | j d D S( s
Retrieve selector users for given version
:param version: selector version, e.g 7.2
:return: dict user: version, e.g. {user: alt-php72, user1: alt-php72}
R s/ /usr/bin/selectorctl --list-users --version={v}t vc 3 s* | ] } | r | t d f Vq d S( s alt-phpN( R ( t .0t u( R ( s3 /usr/share/lve/modlscapi/user/selector_usage_lib.pys 2 s t ,( R R t formatt dictt split( R t users( ( R s3 /usr/share/lve/modlscapi/user/selector_usage_lib.pyt get_selector_users+ s $c C sD t s t St } x$ t D] } | j t | q# W| S( sY
Retrieve versions set for users in selector
:return: dict { user: version }
( R R! R t updateR$ ( t users_verR ( ( s3 /usr/share/lve/modlscapi/user/selector_usage_lib.pyt get_selector_usage5 s c C s t d j d } | j | d k r. | Sd | k r d t k r t | } t | } t | } t | j | t | \ } } | | |